import { Entity, ManyToOne, PrimaryKey, Property } from '@mikro-orm/core'
import { BaseEntity } from '#application/bases/baseEntity'
import { User } from './user'

@Entity()
export class PasswordResetToken extends BaseEntity {
  @PrimaryKey()
  id!: number

  @ManyToOne(() => User)
  user!: User

  @Property({ unique: true })
  token!: string

  @Property()
  createdAt = new Date()
}
