import { Entity, Enum, ManyToOne, OneToOne, PrimaryKey, Property } from '@mikro-orm/core'
import { BaseEntity } from '#application/bases/baseEntity'
import { Zone } from './zone'
import { ZoneEventTileType } from '#application/enums'
import { ZoneEventTileTeleport } from './zoneEventTileTeleport'

@Entity()
export class ZoneEventTile extends BaseEntity {
  @PrimaryKey()
  id!: string

  @ManyToOne(() => Zone)
  zone!: Zone

  @Enum(() => ZoneEventTileType)
  type!: ZoneEventTileType

  @Property()
  positionX!: number

  @Property()
  positionY!: number

  @OneToOne(() => ZoneEventTileTeleport, (teleport) => teleport.zoneEventTile)
  teleport?: ZoneEventTileTeleport
}
